# -*- coding: utf-8 -*-
import sys
reload(sys)
sys.setdefaultencoding("utf-8")
import os
import time
import oss2
import logging
import json
import subprocess

path1 = '/mnt/disk001/dcl_data_process/src/python2/pjibot_delivery/'
path2 = '/mnt/disk001/dcl_data_process/src/python3/pjibot_outdoor/'

logging.basicConfig(filename=path1 + 'log/xosc-pjibot_delivery.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

key1 = 'pjibot_delivery/'
sleep_time = 10  # 每多少秒扫描一次
error_bag_json = "/mnt/disk001/dcl_data_process/src/python2/pjibot_delivery/xosc-errorBag.json"


def parse_json_to_string_array(file_path):
    try:
        # 打开并读取JSON文件（Python 2中不支持encoding参数，需要使用codecs模块或处理文件读取后的编码）
        with open(file_path, 'r') as file:
            # 读取文件内容
            file_content = file.read()
            # 解析JSON内容（Python 2中json.loads用于解析字符串）
            data = json.loads(file_content.decode('utf-8'))  # 假设文件是UTF-8编码，这里需要手动解码

        # 检查数据是否是一个列表，并且列表中的元素是否是字符串
        if isinstance(data, list):
            for item in data:
                if not isinstance(item, basestring):  # Python 2中字符串类型包括str和unicode，用basestring检查
                    raise ValueError("JSON数组中的元素不是字符串")
            return data
        else:
            return []
    except Exception as e:
        return []


def list_to_json_file(data, file_path):
    """
    将列表转换为JSON格式并写入指定的文件路径。
    如果文件已存在，则覆盖它。

    参数:
    data (list): 要转换为JSON的列表。
    file_path (str): 要写入JSON数据的文件路径。
    """
        # 确保所有字符串都是 Unicode 类型
    def ensure_unicode(obj):
        if isinstance(obj, dict):
            return {ensure_unicode(k): ensure_unicode(v) for k, v in obj.items()}
        elif isinstance(obj, list):
            return [ensure_unicode(i) for i in obj]
        elif isinstance(obj, str):  # Python 2 的 `str`
            return obj.decode('utf-8')  # 解码为 Unicode
        else:
            return obj

    # 转换数据
    data = ensure_unicode(data)
    # 将列表转换为JSON格式的字符串，并确保输出为UTF-8编码的字符串
    json_data = json.dumps(data, ensure_ascii=False, indent=4)
    json_data_utf8 = json_data.encode('utf-8')  # 编码为UTF-8

    # 以二进制写入模式打开文件
    with open(file_path, 'wb') as file:  # 使用 'wb' 模式
        # 将UTF-8编码的JSON字符串写入文件
        file.write(json_data_utf8)

def generate_xosc(parse_prefix, local_parse_dir, local_delete_list):
    try:
        # 进入指定目录
        os.chdir(path2)

        # 构造命令
        command2 = 'python3 jiqiren_outdoor.py {} 0'.format(local_parse_dir[:-1])  # 配送机器人0 巡检机器人1
        logging.info("进入目录 %s 调用命令2: %s", path2, command2)

        # 使用 subprocess.Popen 运行命令并捕获输出
        try:
            process = subprocess.Popen(command2, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            stdout, stderr = process.communicate()  # 等待进程执行完成并获取输出
            if process.returncode == 0:
                logging.info("命令输出: %s", stdout.decode("utf-8"))
            else:
                logging.error("命令执行失败，错误码: %d", process.returncode)
                logging.error("命令错误输出: %s", stderr.decode("utf-8"))
        except Exception as e:
            logging.error("命令执行过程中发生异常: %s", e)
        local_xosc_path2 = local_parse_dir + 'simulation/xosc/openx_outdoor0.xosc'
        bucket.put_object_from_file(parse_prefix + 'scenario.xosc', local_xosc_path2)
        bucket.put_object_from_file(parse_prefix + 'scenario_hmi.xosc', local_xosc_path2)
        logging.info("上传 scenario_hmi.xosc 成功: %s" % str(parse_prefix + 'scenario.xosc'))
        local_delete_list.append(local_xosc_path2)
    except Exception as e:
        error_bag_list = parse_json_to_string_array(error_bag_json)
        error_bag_list.append(parse_prefix)
        list_to_json_file(error_bag_list, error_bag_json)
        logging.exception("生成xosc报错: %s" % str(e))


'''
cname：http://open-bucket.oss.icvdc.com
内网endpoint: oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com
oss桶名： open-bucket
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
'''
# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'pji-bucket1')
    while True:
        try:
            logging.info("开始新一轮扫描")
            local_delete_list = []
            oss_delete_list = []
            prefix_list = []
            # 2 获取已经上传完成的所有目录并分组
            for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
                try:
                    # 获取合并后的包
                    merged_bag_object_key = str(obj1.key)
                    if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                        merged_bag_object_key_split = merged_bag_object_key.split('/')
                        merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                        parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                        parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                        xosc_done = False
                        csv1_done = False
                        csv2_done = False
                        for obj3 in oss2.ObjectIterator(bucket, prefix=str(parse_prefix_full)):
                            if '/scenario_hmi.xosc' in str(obj3.key): # 仿真使用的 scenario_hmi.xosc 所以必须有
                                xosc_done = True
                            if '/objects_pji.csv' in str(obj3.key):
                                csv1_done = True
                            if '/pos_pji.csv' in str(obj3.key):
                                csv2_done = True
                        if xosc_done:
                            continue
                        if not csv1_done:
                            logging.info("不存在 /objects_pji.csv: %s" % str(parse_prefix_full))
                            continue
                        if not csv2_done:
                            logging.info("不存在 /pos_pji.csv: %s" % str(parse_prefix_full))
                            continue
                        error_bag_list = parse_json_to_string_array(error_bag_json)
                        if str(parse_prefix_full) in error_bag_list:
                            continue
                        logging.info("需要生成 scenario_hmi.xosc: %s" % str(parse_prefix_full))
                        local_dir_full = path1 + parse_prefix_full
                        if not os.path.exists(local_dir_full):
                            os.makedirs(local_dir_full)
                        bucket.get_object_to_file(parse_prefix_full + 'objects_pji.csv',
                                                  local_dir_full + 'objects_pji.csv')
                        bucket.get_object_to_file(parse_prefix_full + 'pos_pji.csv', local_dir_full + 'pos_pji.csv')
                        generate_xosc(parse_prefix_full, local_dir_full, local_delete_list)
                except Exception as e:
                    logging.exception("局部异常处理: %s", str(e))
            # 删除本地临时文件
            if len(local_delete_list) > 0:
                for local_delete in local_delete_list:
                    try:
                        os.remove(local_delete)
                    except Exception as e:
                        logging.exception("删除本地临时文件报错: %s" % str(e))
            time.sleep(sleep_time)
        except Exception as e:
            logging.exception("全局异常处理: %s", str(e))
